org.icefaces.ace.component.drawerpanel

## Class DrawerPanelBase

- java.lang.Object
- - javax.faces.component.UIComponent
  - - javax.faces.component.UIComponentBase
    - - javax.faces.component.UIPanel
      - - org.icefaces.ace.component.drawerpanel.DrawerPanelBase

- All Implemented Interfaces:
    java.util.EventListener, javax.faces.component.behavior.ClientBehaviorHolder, javax.faces.component.PartialStateHolder, javax.faces.component.StateHolder, javax.faces.component.TransientStateHolder, javax.faces.event.ComponentSystemEventListener, javax.faces.event.FacesListener, javax.faces.event.SystemEventListenerHolder, IceClientBehaviorHolder, IDrawerPanel
  Direct Known Subclasses:
    DrawerPanel

      public abstract class DrawerPanelBase
      extends javax.faces.component.UIPanel
      implements IDrawerPanel, IceClientBehaviorHolder

  The DrawerPanel is a container component that can overlay other elements on the page, appearing from an edge of the page. The DrawerPanel has several customization options such as modal, width, position.

  For more information, see the DrawerPanel Wiki Documentation.

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `protected static class` | `DrawerPanelBase.PropertyKeys`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static java.lang.String` | `COMPONENT_TYPE`
    `static java.lang.String` | `RENDERER_TYPE`

    - ### Fields inherited from class javax.faces.component.UIPanel

      `COMPONENT_FAMILY`

    - ### Fields inherited from class javax.faces.component.UIComponent

      `ATTRS_WITH_DECLARED_DEFAULT_VALUES, BEANINFO_KEY, bindings, COMPOSITE_COMPONENT_TYPE_KEY, COMPOSITE_FACET_NAME, CURRENT_COMPONENT, CURRENT_COMPOSITE_COMPONENT, FACETS_KEY, HONOR_CURRENT_COMPONENT_ATTRIBUTES_PARAM_NAME, VIEW_LOCATION_KEY`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `DrawerPanelBase()`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addClientBehavior(java.lang.String eventName, javax.faces.component.behavior.ClientBehavior behavior)`
    `java.lang.String` | `getContainer()` Return the value of the `container` property.
    `java.lang.String` | `getDefaultEventName()`
    `java.lang.String` | `getDefaultExecute(java.lang.String event)`
    `java.lang.String` | `getDefaultRender(java.lang.String event)`
    `java.lang.String` | `getEffect()` Return the value of the `effect` property.
    `java.util.Collection<java.lang.String>` | `getEventNames()`
    `java.lang.String` | `getFamily()`
    `java.lang.String` | `getHeader()` Return the value of the `header` property.
    `int` | `getHeight()` Return the value of the `height` property.
    `java.lang.String` | `getListenerArgument(java.lang.String event)`
    `java.lang.String` | `getOnClose()` Return the value of the `onClose` property.
    `java.lang.String` | `getOnOpen()` Return the value of the `onOpen` property.
    `java.lang.String` | `getPosition()` Return the value of the `position` property.
    `java.lang.String` | `getSetFocus()` Return the value of the `setFocus` property.
    `java.lang.String` | `getStyle()` Return the value of the `style` property.
    `java.lang.String` | `getStyleClass()` Return the value of the `styleClass` property.
    `int` | `getWidth()` Return the value of the `width` property.
    `int` | `getZindex()` Return the value of the `zindex` property.
    `boolean` | `isCloseOnEscape()` Return the value of the `closeOnEscape` property.
    `boolean` | `isCloseOnOutsideClick()` Return the value of the `closeOnOutsideClick` property.
    `boolean` | `isModal()` Return the value of the `modal` property.
    `protected boolean` | `isPropertySet(java.lang.String finder)`
    `boolean` | `isShowHandleClose()` Return the value of the `showHandleClose` property.
    `boolean` | `isShowHandleOpen()` Return the value of the `showHandleOpen` property.
    `boolean` | `isShowHeader()` Return the value of the `showHeader` property.
    `boolean` | `isVisible()` Return the value of the `visible` property.
    `void` | `setCloseOnEscape(boolean closeOnEscape)` Set the value of the `closeOnEscape` property.
    `void` | `setCloseOnOutsideClick(boolean closeOnOutsideClick)` Set the value of the `closeOnOutsideClick` property.
    `void` | `setContainer(java.lang.String container)` Set the value of the `container` property.
    `void` | `setEffect(java.lang.String effect)` Set the value of the `effect` property.
    `void` | `setHeader(java.lang.String header)` Set the value of the `header` property.
    `void` | `setHeight(int height)` Set the value of the `height` property.
    `void` | `setModal(boolean modal)` Set the value of the `modal` property.
    `void` | `setOnClose(java.lang.String onClose)` Set the value of the `onClose` property.
    `void` | `setOnOpen(java.lang.String onOpen)` Set the value of the `onOpen` property.
    `void` | `setPosition(java.lang.String position)` Set the value of the `position` property.
    `void` | `setSetFocus(java.lang.String setFocus)` Set the value of the `setFocus` property.
    `void` | `setShowHandleClose(boolean showHandleClose)` Set the value of the `showHandleClose` property.
    `void` | `setShowHandleOpen(boolean showHandleOpen)` Set the value of the `showHandleOpen` property.
    `void` | `setShowHeader(boolean showHeader)` Set the value of the `showHeader` property.
    `void` | `setStyle(java.lang.String style)` Set the value of the `style` property.
    `void` | `setStyleClass(java.lang.String styleClass)` Set the value of the `styleClass` property.
    `void` | `setValueExpression(java.lang.String name, javax.el.ValueExpression binding)`
    `void` | `setVisible(boolean visible)` Set the value of the `visible` property.
    `void` | `setWidth(int width)` Set the value of the `width` property.
    `void` | `setZindex(int zindex)` Set the value of the `zindex` property.

    - ### Methods inherited from class javax.faces.component.UIComponentBase

      `addFacesListener, broadcast, clearInitialState, decode, encodeBegin, encodeChildren, encodeEnd, findComponent, getAttributes, getChildCount, getChildren, getClientBehaviors, getClientId, getFacesContext, getFacesListeners, getFacet, getFacetCount, getFacets, getFacetsAndChildren, getId, getListenersForEventClass, getParent, getRenderer, getRendererType, getRendersChildren, getValueBinding, invokeOnComponent, isRendered, isTransient, markInitialState, processDecodes, processRestoreState, processSaveState, processUpdates, processValidators, queueEvent, removeFacesListener, restoreAttachedState, restoreState, saveAttachedState, saveState, setId, setParent, setRendered, setRendererType, setTransient, setValueBinding, subscribeToEvent, unsubscribeFromEvent`

    - ### Methods inherited from class javax.faces.component.UIComponent

      `encodeAll, getClientId, getCompositeComponentParent, getContainerClientId, getCurrentComponent, getCurrentCompositeComponent, getNamingContainer, getResourceBundleMap, getStateHelper, getStateHelper, getTransientStateHelper, getTransientStateHelper, getValueExpression, initialStateMarked, isCompositeComponent, isInView, isVisitable, popComponentFromEL, processEvent, pushComponentToEL, restoreTransientState, saveTransientState, setInView, visitTree`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface javax.faces.component.behavior.ClientBehaviorHolder

      `getClientBehaviors`

- - ### Field Detail

    - #### COMPONENT_TYPE

          public static final java.lang.String COMPONENT_TYPE

      See Also:
        Constant Field Values

    - #### RENDERER_TYPE

          public static final java.lang.String RENDERER_TYPE

      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### DrawerPanelBase

          public DrawerPanelBase()

  - ### Method Detail

    - #### getFamily

          public java.lang.String getFamily()

      Overrides:
        `getFamily` in class `javax.faces.component.UIPanel`

    - #### setCloseOnEscape

          public void setCloseOnEscape(boolean closeOnEscape)

      Set the value of the `closeOnEscape` property.

      Contents: Boolean value that specifies whether the drawer should be closed when it has focus and the user presses the escape (ESC) key.

      Specified by:
        `setCloseOnEscape` in interface `IDrawerPanel`

    - #### isCloseOnEscape

          public boolean isCloseOnEscape()

      Return the value of the `closeOnEscape` property.

      Contents: Boolean value that specifies whether the drawer should be closed when it has focus and the user presses the escape (ESC) key. Default = 'true'.

      Specified by:
        `isCloseOnEscape` in interface `IDrawerPanel`

    - #### setCloseOnOutsideClick

          public void setCloseOnOutsideClick(boolean closeOnOutsideClick)

      Set the value of the `closeOnOutsideClick` property.

      Contents: Boolean value that specifies whether the drawer should be closed when the user clicks (or touches) any part of the page outside the drawer.

      Specified by:
        `setCloseOnOutsideClick` in interface `IDrawerPanel`

    - #### isCloseOnOutsideClick

          public boolean isCloseOnOutsideClick()

      Return the value of the `closeOnOutsideClick` property.

      Contents: Boolean value that specifies whether the drawer should be closed when the user clicks (or touches) any part of the page outside the drawer. Default = 'true'.

      Specified by:
        `isCloseOnOutsideClick` in interface `IDrawerPanel`

    - #### setContainer

          public void setContainer(java.lang.String container)

      Set the value of the `container` property.

      Contents: Specify the container whose edges the drawer will appear from. The default mode is the entire window, but it's possible to specify a client id of an element on the page to have the drawer.

      Specified by:
        `setContainer` in interface `IDrawerPanel`

    - #### getContainer

          public java.lang.String getContainer()

      Return the value of the `container` property.

      Contents: Specify the container whose edges the drawer will appear from. The default mode is the entire window, but it's possible to specify a client id of an element on the page to have the drawer. Default = 'window'.

      Specified by:
        `getContainer` in interface `IDrawerPanel`

    - #### setEffect

          public void setEffect(java.lang.String effect)

      Set the value of the `effect` property.

      Contents: Effect to use when opening and closing the drawer. Possible values are 'drop', 'fade', and 'slide'. The default effect is 'slide'.

      Specified by:
        `setEffect` in interface `IDrawerPanel`

    - #### getEffect

          public java.lang.String getEffect()

      Return the value of the `effect` property.

      Contents: Effect to use when opening and closing the drawer. Possible values are 'drop', 'fade', and 'slide'. The default effect is 'slide'. Default = 'slide'.

      Specified by:
        `getEffect` in interface `IDrawerPanel`

    - #### setHeader

          public void setHeader(java.lang.String header)

      Set the value of the `header` property.

      Contents: Text that will appear in the header of the drawer.

      Specified by:
        `setHeader` in interface `IDrawerPanel`

    - #### getHeader

          public java.lang.String getHeader()

      Return the value of the `header` property.

      Contents: Text that will appear in the header of the drawer.

      Specified by:
        `getHeader` in interface `IDrawerPanel`

    - #### setHeight

          public void setHeight(int height)

      Set the value of the `height` property.

      Contents: Height of the element in pixels. Default (not specified or value <= 0) is auto. If auto, IE7 may not size or position properly. This attribute only applies if the 'position' is 'top' or 'bottom'.

      Specified by:
        `setHeight` in interface `IDrawerPanel`

    - #### getHeight

          public int getHeight()

      Return the value of the `height` property.

      Contents: Height of the element in pixels. Default (not specified or value <= 0) is auto. If auto, IE7 may not size or position properly. This attribute only applies if the 'position' is 'top' or 'bottom'. Default = 'Integer.MIN_VALUE'.

      Specified by:
        `getHeight` in interface `IDrawerPanel`

    - #### setModal

          public void setModal(boolean modal)

      Set the value of the `modal` property.

      Contents: Boolean value that specifies whether the document should be shielded with a partially transparent mask to require the user to close the panel before being able to activate any elements in the document.

      Specified by:
        `setModal` in interface `IDrawerPanel`

    - #### isModal

          public boolean isModal()

      Return the value of the `modal` property.

      Contents: Boolean value that specifies whether the document should be shielded with a partially transparent mask to require the user to close the panel before being able to activate any elements in the document. Default = 'false'.

      Specified by:
        `isModal` in interface `IDrawerPanel`

    - #### setOnClose

          public void setOnClose(java.lang.String onClose)

      Set the value of the `onClose` property.

      Contents: Javascript code to be executed when closing the drawer.

      Specified by:
        `setOnClose` in interface `IDrawerPanel`

    - #### getOnClose

          public java.lang.String getOnClose()

      Return the value of the `onClose` property.

      Contents: Javascript code to be executed when closing the drawer.

      Specified by:
        `getOnClose` in interface `IDrawerPanel`

    - #### setOnOpen

          public void setOnOpen(java.lang.String onOpen)

      Set the value of the `onOpen` property.

      Contents: Javascript code to be executed when opening the drawer.

      Specified by:
        `setOnOpen` in interface `IDrawerPanel`

    - #### getOnOpen

          public java.lang.String getOnOpen()

      Return the value of the `onOpen` property.

      Contents: Javascript code to be executed when opening the drawer.

      Specified by:
        `getOnOpen` in interface `IDrawerPanel`

    - #### setPosition

          public void setPosition(java.lang.String position)

      Set the value of the `position` property.

      Contents: Specifies the side on which the drawer should be displayed. Possible values are 'left', 'right', 'top', 'bottom'

      Specified by:
        `setPosition` in interface `IDrawerPanel`

    - #### getPosition

          public java.lang.String getPosition()

      Return the value of the `position` property.

      Contents: Specifies the side on which the drawer should be displayed. Possible values are 'left', 'right', 'top', 'bottom' Default = 'left'.

      Specified by:
        `getPosition` in interface `IDrawerPanel`

    - #### setSetFocus

          public void setSetFocus(java.lang.String setFocus)

      Set the value of the `setFocus` property.

      Contents: Specifies the ID of the component that should receive focus when the drawer is opened.

      Specified by:
        `setSetFocus` in interface `IDrawerPanel`

    - #### getSetFocus

          public java.lang.String getSetFocus()

      Return the value of the `setFocus` property.

      Contents: Specifies the ID of the component that should receive focus when the drawer is opened.

      Specified by:
        `getSetFocus` in interface `IDrawerPanel`

    - #### setShowHandleClose

          public void setShowHandleClose(boolean showHandleClose)

      Set the value of the `showHandleClose` property.

      Contents: Boolean value that specifies whether to display a three-horizontal-bars icon inside the drawer to close it. This handle will appear at the opper left corner of the drawer, inside the drawer's header.

      Specified by:
        `setShowHandleClose` in interface `IDrawerPanel`

    - #### isShowHandleClose

          public boolean isShowHandleClose()

      Return the value of the `showHandleClose` property.

      Contents: Boolean value that specifies whether to display a three-horizontal-bars icon inside the drawer to close it. This handle will appear at the opper left corner of the drawer, inside the drawer's header. Default = 'true'.

      Specified by:
        `isShowHandleClose` in interface `IDrawerPanel`

    - #### setShowHandleOpen

          public void setShowHandleOpen(boolean showHandleOpen)

      Set the value of the `showHandleOpen` property.

      Contents: Boolean value that specifies whether to display a three-horizontal-bars icon to open the drawer. This handle will appear at the upper left corner of the viewport if the 'position' is 'left' or 'top', at the uper right corner of the viewport if the 'position' is 'right', and at the lower left corner of the viewport if the 'position' is 'bottom'. This handle will only be displayed if the 'container' is set to 'window'. If a handle is desired when applying the drawer to a specific container, it has to be done manually; please consult the wiki page for this component for guidelines and sample markup.

      Specified by:
        `setShowHandleOpen` in interface `IDrawerPanel`

    - #### isShowHandleOpen

          public boolean isShowHandleOpen()

      Return the value of the `showHandleOpen` property.

      Contents: Boolean value that specifies whether to display a three-horizontal-bars icon to open the drawer. This handle will appear at the upper left corner of the viewport if the 'position' is 'left' or 'top', at the uper right corner of the viewport if the 'position' is 'right', and at the lower left corner of the viewport if the 'position' is 'bottom'. This handle will only be displayed if the 'container' is set to 'window'. If a handle is desired when applying the drawer to a specific container, it has to be done manually; please consult the wiki page for this component for guidelines and sample markup. Default = 'true'.

      Specified by:
        `isShowHandleOpen` in interface `IDrawerPanel`

    - #### setShowHeader

          public void setShowHeader(boolean showHeader)

      Set the value of the `showHeader` property.

      Contents: Boolean value that specifies whether the drawer should have a header (default true). If 'showHandleClose' is set to true, a header will be shown regardless of the value of this attribute.

      Specified by:
        `setShowHeader` in interface `IDrawerPanel`

    - #### isShowHeader

          public boolean isShowHeader()

      Return the value of the `showHeader` property.

      Contents: Boolean value that specifies whether the drawer should have a header (default true). If 'showHandleClose' is set to true, a header will be shown regardless of the value of this attribute. Default = 'true'.

      Specified by:
        `isShowHeader` in interface `IDrawerPanel`

    - #### setStyle

          public void setStyle(java.lang.String style)

      Set the value of the `style` property.

      Contents: Style to apply to the container element.

      Specified by:
        `setStyle` in interface `IDrawerPanel`

    - #### getStyle

          public java.lang.String getStyle()

      Return the value of the `style` property.

      Contents: Style to apply to the container element.

      Specified by:
        `getStyle` in interface `IDrawerPanel`

    - #### setStyleClass

          public void setStyleClass(java.lang.String styleClass)

      Set the value of the `styleClass` property.

      Contents: Style class of the main container of the drawer.

      Specified by:
        `setStyleClass` in interface `IDrawerPanel`

    - #### getStyleClass

          public java.lang.String getStyleClass()

      Return the value of the `styleClass` property.

      Contents: Style class of the main container of the drawer.

      Specified by:
        `getStyleClass` in interface `IDrawerPanel`

    - #### setVisible

          public void setVisible(boolean visible)

      Set the value of the `visible` property.

      Contents: This attribute can be used to toggle visibility on the server, rendered should not be used that way, setting rendered=false on a visible modal drawer will not remove the modality layer, visible=false must be set first (or client-side JS function called).

      Specified by:
        `setVisible` in interface `IDrawerPanel`

    - #### isVisible

          public boolean isVisible()

      Return the value of the `visible` property.

      Contents: This attribute can be used to toggle visibility on the server, rendered should not be used that way, setting rendered=false on a visible modal drawer will not remove the modality layer, visible=false must be set first (or client-side JS function called). Default = 'false'.

      Specified by:
        `isVisible` in interface `IDrawerPanel`

    - #### setWidth

          public void setWidth(int width)

      Set the value of the `width` property.

      Contents: Width of the element in pixels. Default (not specified or value <= 0) is auto. If auto, IE7 may not size or position properly. This attribute only applies when the 'position' is 'left' or 'right'.

      Specified by:
        `setWidth` in interface `IDrawerPanel`

    - #### getWidth

          public int getWidth()

      Return the value of the `width` property.

      Contents: Width of the element in pixels. Default (not specified or value <= 0) is auto. If auto, IE7 may not size or position properly. This attribute only applies when the 'position' is 'left' or 'right'. Default = 'Integer.MIN_VALUE'.

      Specified by:
        `getWidth` in interface `IDrawerPanel`

    - #### setZindex

          public void setZindex(int zindex)

      Set the value of the `zindex` property.

      Contents: z-index property to control overlapping with other elements.

      Specified by:
        `setZindex` in interface `IDrawerPanel`

    - #### getZindex

          public int getZindex()

      Return the value of the `zindex` property.

      Contents: z-index property to control overlapping with other elements. Default = '1000'.

      Specified by:
        `getZindex` in interface `IDrawerPanel`

    - #### isPropertySet

          protected boolean isPropertySet(java.lang.String finder)

    - #### setValueExpression

          public void setValueExpression(java.lang.String name,
                                         javax.el.ValueExpression binding)

      Overrides:
        `setValueExpression` in class `javax.faces.component.UIComponent`

    - #### getEventNames

          public java.util.Collection<java.lang.String> getEventNames()

      Specified by:
        `getEventNames` in interface `javax.faces.component.behavior.ClientBehaviorHolder`
      Overrides:
        `getEventNames` in class `javax.faces.component.UIComponentBase`

    - #### getDefaultEventName

          public java.lang.String getDefaultEventName()

      Specified by:
        `getDefaultEventName` in interface `javax.faces.component.behavior.ClientBehaviorHolder`
      Overrides:
        `getDefaultEventName` in class `javax.faces.component.UIComponentBase`

    - #### getDefaultRender

          public java.lang.String getDefaultRender(java.lang.String event)

      Specified by:
        `getDefaultRender` in interface `IceClientBehaviorHolder`

    - #### getDefaultExecute

          public java.lang.String getDefaultExecute(java.lang.String event)

      Specified by:
        `getDefaultExecute` in interface `IceClientBehaviorHolder`

    - #### getListenerArgument

          public java.lang.String getListenerArgument(java.lang.String event)

      Specified by:
        `getListenerArgument` in interface `IceClientBehaviorHolder`

    - #### addClientBehavior

          public void addClientBehavior(java.lang.String eventName,
                                        javax.faces.component.behavior.ClientBehavior behavior)

      Specified by:
        `addClientBehavior` in interface `javax.faces.component.behavior.ClientBehaviorHolder`
      Overrides:
        `addClientBehavior` in class `javax.faces.component.UIComponentBase`

Copyright 2025 ICEsoft Technologies Canada, Corp. All Rights Reserved.